// pages/bankDraft/add/add.js
import * as UTIL from '../../../utils/util.js';
import * as API from '../../../utils/API.js';
const app = getApp();
Page({

  /**
   * 页面的初始数据
   */
  data: {
    isIPX: app.globalData.isIPX,
    showOrderType:false,
    showOrderStatus:false,
    form:{
      orderNum: "", //汇票号码 必填
      orderType: "",  //汇票类型 必填
      orderAmount: "",//汇票金额 必填
      billPayUnit: "", //付票单位 必填
      billReceiveUnit: "", // 收票单位 必填
      startTime: "2020-01-01", //开票日期 必填
      endTime: "2020-01-01", //到期日期 必填
      orderStatus: "", //汇票状态 必填  1在库 2转付中 3转付 4承兑
      remark: "",
    },
    orderStatusOptions:[],
    orderTypeOptions:[],
    showBtn:true,
    showStartTime:false,
    showEndTime:false,
    status:0,
    orderTypeindex:0,
    orderStatusindex:0
  },

  /**
   * 生命周期函数--监听页面加载
   */
  onLoad(options) {
    if(options.id!=null&&options.id!=""){
      let that = this
      this.setData({id:options.id})
      UTIL.httpRequest(API.URL_GET_MONEYORDERDETAIL + this.data.id, {method:'GET'}, {
        success: (res) => {
          if(res.data.orderStatus!='1'){
              this.setData({'showBtn':false});
          }
          //汇票类型
          UTIL.httpRequest(API.URL_GET_GETDICTTYPE + 'order_type', {method:'GET'}, {
            success: (rr) => {
              this.setData({
                orderTypeOptions:rr.data
              });
              this.data.orderTypeOptions.map(r => {
                if(r.dictValue == res.data.orderType){
                    res.data.orderTypeText = r.dictLabel
                    that.setData({'form':res.data});
                }
              })
            }
          })
          //汇票状态
          UTIL.httpRequest(API.URL_GET_GETDICTTYPE + 'order_status', {method:'GET'}, {
            success: (rr) => {
              this.setData({
                orderStatusOptions:rr.data
              });
              this.data.orderStatusOptions.map(r => {
                if(r.dictValue == res.data.orderStatus){
                    res.data.orderStatusText = r.dictLabel
                    that.setData({'form':res.data});
                }
              })
            }
          })
        }
      })
    }else{
     this.onShow()
    }
  },
  onConfirmStartTime(e){
    let data = this.getNewDate(new Date(e.detail.value));
    this.setData({'form.startTime':data});
  },
  onConfirmEndTime(e){
    let data = this.getNewDate(new Date(e.detail.value));
    this.setData({'form.endTime':data});
  },
  getNewDate(date){
    //date是传过来的时间戳，注意需为13位，10位需*1000
    //也可以不传,获取的就是当前时间
    var time
    if(date){
       time = new Date(date);
    }else{
       time = new Date();
    }
    var year= time.getFullYear()  //年
    var month = ("0" + (time.getMonth() + 1)).slice(-2); //月
    var day = ("0" + time.getDate()).slice(-2); //日
    var mydate = year + "-" + month + "-" + day;
    return mydate
  },
  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady() {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow() {
    //汇票类型
    UTIL.httpRequest(API.URL_GET_GETDICTTYPE + 'order_type', {method:'GET'}, {
      success: (res) => {
        this.setData({
          orderTypeOptions:res.data,
          'form.orderType':res.data[0].dictValue
        });
      }
    })
    //汇票状态
    UTIL.httpRequest(API.URL_GET_GETDICTTYPE + 'order_status', {method:'GET'}, {
      success: (res) => {
        this.setData({
          orderStatusOptions:res.data,
          'form.orderStatus':res.data[0].dictValue
        });
      }
    })
  },
  openBox(even){
    console.log(even.currentTarget.dataset.name);
    this.setData({
      [even.currentTarget.dataset.name]:true
    })
  },
  onChange(event){
    console.log(event);
    this.setData({
      [event.currentTarget.dataset.value]: event.detail,
    })
  },
  closeBox(even){
    console.log(even.currentTarget.dataset.name);
    this.setData({
      [even.currentTarget.dataset.name]:false
    })
  },
  onConfirmorderType (e) {
    let obj =  e.detail.value;
    this.setData({
      'form.orderType':this.data.orderTypeOptions[obj].dictValue,
      'orderTypeindex':obj
    })
  },
  onConfirmorderStatus (e) {
    let obj =  e.detail.value;
    this.setData({
      'form.orderStatus':this.data.orderStatusOptions[obj].dictValue,
      'orderStatusindex':obj
    })
  },
  goSubmit(){
    if(this.data.form.orderNum===''||this.data.form.orderNum==null){ //汇票号码
      UTIL.showToastNoneIcon('请填写汇票号码！');
      return false;
    }else if(this.data.form.orderType===''||this.data.form.orderType==null){  //汇票类型
      UTIL.showToastNoneIcon('汇票类型不能为空！');
      return false;
    }else if(this.data.form.orderAmount===''||this.data.form.orderAmount==null){  //出票金额
      UTIL.showToastNoneIcon('请输入出票金额！');
      return false;
    }else if(this.data.form.billPayUnit===''||this.data.form.billPayUnit==null){  //付票单位
      UTIL.showToastNoneIcon('请输入付票单位！');
      return false;
    }else if(this.data.form.billReceiveUnit === ''||this.data.form.billReceiveUnit==null){//收票单位
      UTIL.showToastNoneIcon('请输入收票单位！');
      return false;
    }else if(this.data.form.startTime === ''||this.data.form.startTime==null){//开票日期
      UTIL.showToastNoneIcon('请输入开票日期！');
      return false;
    }else if(this.data.form.endTime === ''||this.data.form.endTime==null){//到期日期
      UTIL.showToastNoneIcon('请输入到期日期！');
      return false;
    }else if(this.data.form.orderStatus === ''||this.data.form.orderStatus==null){//联行号
      UTIL.showToastNoneIcon('联行号不能为空！');
      return false;
    }else if(this.data.form.orderStatus === ''||this.data.form.orderStatus==null){//联行号
      UTIL.showToastNoneIcon('联行号不能为空！');
      return false;
    }else if(this.data.status=='0'){
      this.setData({'status':'1'})
      var that = this;
      that.data.form.method = 'POST';
      if(that.data.form.id==""||that.data.form.id==null){
        UTIL.httpRequest(API.URL_POST_MONEYORDERADD, that.data.form , {
          success: (res) => {
            this.setData({'status':0})
            if(res.code == 200){
              UTIL.showToastNoneIcon('新增成功');
              setTimeout(function(){
                wx.navigateBack({
                  delta:1
                })
              },2000)
            }else{
              UTIL.showToastNoneIcon('新增失败：'+res.msg);
            }
          }
        })
      }else{
        UTIL.httpRequest(API.URL_POST_MONEYORDERUPDATE, that.data.form , {
          success: (res) => {
            this.setData({'status':0})
            if(res.code == 200){
              UTIL.showToastNoneIcon('修改成功');
              setTimeout(function(){
                wx.navigateBack({
                  delta:1
                })
              },2000)
            }else{
              UTIL.showToastNoneIcon('修改失败：'+res.msg);
            }
          }
        })
      }
    }   
  },
  onConfirmTime(event){
    this.setData({
      [event.currentTarget.dataset.name]: false,
      [event.currentTarget.dataset.value]: UTIL.formatDate(event.detail),
    });
  },
  openBox(even){
    console.log(even.currentTarget.dataset.name);
    this.setData({
      [even.currentTarget.dataset.name]:true
    })
  },
  closeBox(even){
    console.log(even.currentTarget.dataset.name);
    this.setData({
      [even.currentTarget.dataset.name]:false
    })
  },
  back:function(){
    wx.navigateBack({
      delta: 1
    })
  },
  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide() {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload() {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh() {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom() {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage() {

  }
})